package gltest;

/**
 * Represents the object as a grid of vectors and their normals
 */
public class Grid3D {
	
	private int uCount, vCount;
	
	private Vector3D[][] pointsOnSurface;
	private Vector3D[][] normals;
	
	public Grid3D( int vCount, int uCount ) {
		this.vCount = vCount;
		this.uCount = uCount;
		this.pointsOnSurface = new Vector3D[uCount][vCount];
		this.normals = new Vector3D[uCount + 1][vCount + 1];
	}
	
	public void setVertex(int i, int j, Vector3D v) {
		pointsOnSurface[i][j] = v;
	}
	
	public void setNormal(int i, int j, Vector3D v) {
		normals[i][j] = v.normalized();
	}
	
	public Vector3D[][] getPointsOnSurface() {
		return pointsOnSurface;
	}

	public int getVCount() {
		return vCount;
	}

	public int getUCount() {
		return uCount;
	}

	public Vector3D getUnitNormal(int l, int i) {
		return normals[l][i];
	}

}
