package gltest.surfaces;

import gltest.Vector3D;



public class Astroidale extends SurfaceParametric{
	
	
	
	protected void setDefaults() {
		uRes = 16;
		vRes = 10;
		umin = -Math.PI;
		umax = Math.PI;
		vmin = -0.5 * Math.PI;
		vmax = 0.5 * Math.PI;
		setDefaultViewpoint(new Vector3D(10,-10,10));
		setDefaultWindow(-2.5,2.5,-2.5,2.5);
		
		
	}

	//returns cos^r(t)
	static private double cospower(double t,double r){
		return Math.signum(Math.cos(t))*Math.exp(r*Math.log(Math.abs(Math.cos(t))));
	}
	//returns sin^r(t)
	static private double sinpower(double t,double r){
		return Math.signum(Math.sin(t))*Math.exp(r*Math.log(Math.abs(Math.sin(t))));
	}
	
	public Vector3D surfacePoint(double u, double v) {

		double x = 2 * cospower(u,3) * cospower(v,3);
		double y = 2 * sinpower(u,3)*cospower(v,3);
		double z = 2 * sinpower(v,3);
		return new Vector3D(x,y,z);
	}


}
