package gltest.surfaces;

import gltest.Vector3D;


/**
 * Defines the Hyperbolic Paraboloid surface family.
 */
public class HyperbolicParaboloid extends SurfaceParametric{
	
	
	protected void setDefaults() {
		uRes = 18;
		vRes = 18;
		umin = -2.5;
		umax = 2.5;
		vmin = -2.5;
		vmax = 2.5;
		setDefaultViewpoint(new Vector3D(29,16,20)); 
		setDefaultWindow(-8,8,-8,8);
		
	}

	
	public Vector3D surfacePoint(double u, double v) {
		double x = u;
		double y = 2*v;
		double z = u * v;
		return new Vector3D(x,y,z);
	}


}
