package gltest.surfaces;


import gltest.Vector3D;

/**
 * Defines the Single Sheeted Hyperboloid surface family.
 */
public class Hyperboloid extends SurfaceParametric{


	protected void setDefaults() {
		uRes = 18;
		vRes = 18;
		umin = -2;
		umax = 2;
		vmin = 0;
		vmax = 2*Math.PI;
		
		setDefaultViewpoint(new Vector3D(30,20,10)); 
		setDefaultWindow(-5.5,5.5,-5.5,5.5);
	}
	
	static private double sinh(double t){
		return 0.5*(Math.exp(t)-Math.exp(-t));
	}
	
	static private double cosh(double t){
		return 0.5*(Math.exp(t)+Math.exp(-t));
	}
	
	public Vector3D surfacePoint(double u, double v){
		double x=0;
		double y=0;
		double z=0;

		x = cosh(u) * Math.cos(v);
		y = cosh(u) * Math.sin(v);
		z = sinh(u);
	
		return new Vector3D(x,y,z);	
	}
}

