package gltest.surfaces;

import gltest.Vector3D;



/**
 * Defines the Lissajous surface family.
 */
public class LissajousSurface extends SurfaceParametric{

	
	protected void setDefaults() {
		uRes = 18;
		vRes = 18;
		umin = -Math.PI;
		umax = Math.PI;
		vmin = -Math.PI;
		vmax = Math.PI;
		setDefaultViewpoint(new Vector3D(-4.25,-0.67,8.7)); 
		setDefaultWindow(-2,2,-2,2);
	}

	
	static private double sin(double t){
		return Math.sin(t);
	}

	
	public Vector3D surfacePoint(double u, double v) {
		double x = sin(u);
		double y = sin(v);
		double z = sin(0 - 1 * u -v);
		return new Vector3D(x,y,z);
	}


}
