package gltest.surfaces;

import gltest.Vector3D;


/**
 * Defines a Monkey Saddle surface with parametric equations (a*u, b*v, c*(u^3 - 3*v^3)).
 */
public class MonkeySaddle extends SurfaceParametric {
	
	
	protected void setDefaults() {
		uRes = 12;
		vRes = 10;
		umin = -1.5;
		umax = 1.5;
		vmin = -1.5;
		vmax = 1.5;
		setDefaultViewpoint(new Vector3D(6.64,-13,9.3));
		setDefaultWindow(-2.5,2.5,-2.5,2.5);
	}
	
	public Vector3D surfacePoint(double u, double v) {
		double x =  v;
		double y =  u;
		double z = 0.35 * (u * u * u - 3 * u * v * v);
		return new Vector3D(x,y,z);
	}

}
