package gltest.surfaces;

import gltest.Vector3D;


/**
 * Defines a paraboloid with parametric equations
 * (a*v*cos(u), b*v*sin(u), c*(v^2 - 0.5)) 
 */
public class Paraboloid extends SurfaceParametric {
	
	
	protected void setDefaults() {
		umin = 0;
		umax = 2*Math.PI;
		vmin = 0;
		vmax = 1;

		setDefaultWindow(-2, 2, -2, 2);
		setDefaultViewpoint(new Vector3D(20,3,7));
	}
	
	public Vector3D surfacePoint(double u, double v) {
		double x =  v * Math.cos(u);
		double y =  v * Math.sin(u);
		double z = 2.5 * v * v - 2.5/2;
		return new Vector3D(x,y,z);
	}

}
