
package gltest.surfaces;

import gltest.Vector3D;

public class SnailShell  extends SurfaceParametric {


	
	protected void setDefaults() {
		setDefaultViewpoint(new Vector3D(-40,20,0));
		setDefaultWindow(-3.5,3.5,-3.5,3.5);
		umin = -Math.PI;
		umax = Math.PI;
		vmin = -2;
		vmax = 25;
		uRes = 30;
		vRes = 40;
	}
	

	public Vector3D surfacePoint(double u, double v) {
		double auxa = 1;
		double auxb = 1.4;
		double auxc = 0.05;
		double auxd = 6;
		double vv = v+(v-vmin)*(v-vmin)/16;
		double s = Math.exp(-auxc*vv);
		double r = s*(auxa+auxb*Math.cos(u));
		return new Vector3D(r * Math.cos(vv),auxd-s*(auxd+auxb*Math.sin(u)),r * Math.sin(vv));
	}



}